;*****************************************************************************
; t@~RvO piyo move test
; Version 1.01
; By kuran_kuran
;*****************************************************************************

;*****************************************************************************
; NES wb_
;*****************************************************************************
	.inesprg 1
	.ineschr 1
	.inesmir 0
	.inesmap 0

;*****************************************************************************
; 荞݃xN^
;*****************************************************************************
	.bank 1
	.org $FFFA
	.dw	VBLANK	; VBlank interrupt
	.dw	START  	; Reset interrupt
	.dw	IRQ	; interrupt

;*****************************************************************************
; ϐ
;*****************************************************************************
	.bank 0
; Zero Page
	.org $0000
; Tu[`
Arg1	.db	0
Arg2	.db	0
Arg3	.db	0
Arg4	.db	0
Arg5	.db	0
Arg6	.db	0
Arg7	.db	0
Arg8	.db	0
Work1	.db	0
Work2	.db	0
Work3	.db	0
Work4	.db	0
Work5	.db	0
Work6	.db	0
Work7	.db	0
Work8	.db	0
Address	.db	0
Pad	.db	0

; SpriteBuffer
	.org $0300
	.include "spbuf.asm"
; RAM
	.org $0400
; SET_PIYO
PiyoX	.db	0
PiyoY	.db	0
CharNum	.db	0
SprNum	.db	0
Offset	.db	0
; Anime
DirOff	.db	0
Anime	.db	0
AniCnt	.db	0

;*****************************************************************************
; vO
;*****************************************************************************
	.bank 0
	.org $8000

; ********** A荞ݏ
VBLANK:
	rti

; ********** 荞ݏ
IRQ:
	rti

; ********** CvO
START:
	; ********** 
	sei
	cld

	; X^bN
	ldx	#$FF
	txs

	; l[e[ũ~[[h𐅕ɐݒ (cXN[)
;	lda	#%10000000
;	sta	$5FED

	; PPU A VBlank 荞݋֎~
	lda	#%01001000
	sta	$2000

	; VBlank ɂȂ܂Ń[v
INIT_VBLANK_LOOP:
	lda	$2002
	bpl	INIT_VBLANK_LOOP

	; ̓XvCgABG \
	lda	#%00000110
	sta	$2001

	; 
	jsr	INIT_MEMORY

	; pbg
	lda	#0
	sta	<Arg1
	lda	#32
	sta	<Arg2
	lda	#0
	sta	<Arg3
	jsr	PALET_SET

	; XvCg
	jsr	SPRITE_INIT

	; \ݒ
	lda	#112
	sta	PiyoX
	lda	#160
	sta	PiyoY
	lda	#0
	sta	CharNum
	lda	#1
	sta	SprNum
	lda	#0
	sta	Offset

	; XvCgABG \
	lda	#%00011110
	sta	$2001

	; VBlank 荞݋
	lda	#%11001000
	sta	$2000

	; ********** C[v
MAINLOOP:
	; VBlank ɂȂ܂Ń[v
	lda	$2002
	bpl	MAINLOOP

	; PAD ǂݍ
	lda	#$01
	sta	$4016
	lda	#$00
	sta	$4016
	lda	$4016	; A
	lda	$4016	; B
	lda	$4016	; SELECT
	lda	$4016	; START
	lda	$4016	; UP
	and	#1
	beq	NOT_UP
	dec	PiyoY
	lda	#0
	sta	DirOff
NOT_UP:
	lda	$4016	; DOWN
	and	#1
	beq	NOT_DOWN
	inc	PiyoY
	lda	#96
	sta	DirOff
NOT_DOWN:
	lda	$4016	; LEFT
	and	#1
	beq	NOT_LEFT
	dec	PiyoX
	lda	#32
	sta	DirOff
NOT_LEFT:
	lda	$4016	; RIGHT
	and	#1
	beq	NOT_RIGHT
	inc	PiyoX
	lda	#64
	sta	DirOff
NOT_RIGHT:

	; AjJE^
	inc	AniCnt
	lda	#16
	cmp	AniCnt
	bne	ANIME_CNT
	lda	#0
	sta	AniCnt
	lda	#16
	sec
	sbc	Anime
	sta	Anime
ANIME_CNT:

	; Ђ悱\
	lda	Anime
	clc
	adc	DirOff
	sta	Offset
	jsr	SET_PIYO
	jsr	SPRITE_DRAW

	jmp	MAINLOOP

; ********** LN^\
; in :	PiyoX
;	PiyoY
;	CharNum
;	SprNum
SET_PIYO:
	lda	PiyoX
	sta	<Work1
	lda	PiyoY
	sta	<Work2
	lda	CharNum
	clc
	adc	Offset
	sta	<Work3
	lda	SprNum
	asl	a
	asl	a
	sta	<Work4

	ldx	#$00
	lda	#0
	sta	<Work5
SET_PIYO_L2:
	lda	#0
	sta	<Work6
SET_PIYO_L1:
	lda	<Work4
	sta	<Work4
	lda	<Work2
	sta	SpriteBuffer, x
	inx
	lda	<Work3
	sta	SpriteBuffer, x
	inx
	inc	<Work3
	lda	#$00
	sta	SpriteBuffer, x
	inx
	lda	<Work1
	sta	SpriteBuffer, x
	inx
	clc
	adc	#8
	sta	<Work1
	inc	<Work6
	lda	<Work6
	cmp	#4
	bne	SET_PIYO_L1
	lda	PiyoX
	sta	<Work1
	clc
	lda	<Work2
	adc	#8
	sta	<Work2
	inc	<Work5
	lda	<Work5
	cmp	#4
	bne	SET_PIYO_L2

	rts

INIT_MEMORY:
	; XvCgNA
	lda	#0
	sta	<Work1
	ldx	#$00
SPRITE_CLEAR_L1:
	lda	<Work1
	sta	$2003
	clc
	adc	#4
	sta	<Work1
	lda	#240
	sta	$2004
	lda	#$00
	sta	$2004
	sta	$2004
	sta	$2004
	inx
	cpx	#64
	bne	SPRITE_CLEAR_L1

	; BG NA
	; $2000`$23BF
	; $2400`$27BF

	; [y[W[NA
	lda	#$00
	ldx	#$00
ZERO_PAGE_CLEAR:
	sta	<Work1, x
	inx
	bne	ZERO_PAGE_CLEAR

	; NA
	lda	#$00
	sta	<Work1
	lda	#$02
	sta	<Work2
	lda	#$00
	ldx	#$00
MEMORY_CLEAR_L2:
	ldy	#$00
MEMORY_CLEAR_L1:
	sta	[$00], y
	iny
	bne	MEMORY_CLEAR_L1
	inx
	inc	<Work2
	cpx	#$06
	bne	MEMORY_CLEAR_L2

	; BG NA
	jsr	BG_INIT

	rts

; ********** Tu[`
	.include "graphic.asm"

; ********** pbgf[^
PALETTE_00:
PALETTE_DATA:
	.incbin "piyo.dat"
PALETTE_01:
	.incbin "0f_16.dat"

	.bank 2		; oN 2
	.org $0000	; $0000 Jn

	.incbin "piyo.bin"	; LN^f[^ 2KB
	.incbin "piyo.bin"	; LN^f[^ 2KB
	.incbin "piyo.bin"	; LN^f[^ 2KB
	.incbin "piyo.bin"	; LN^f[^ 2KB
